=== debian/changelog ===
openturns (1.2-2) unstable; urgency=low

  * Upload into unstable
  * debian/rules: also set CMAKE_EXE_LINKER_FLAGS with dpkg-buildflags's
    output.

 -- Denis Barbier <barbier@debian.org>  Fri, 09 Aug 2013 22:22:59 +0200

openturns (1.2-1) experimental; urgency=low

  [Julien Schueller]
  * New upstream version 1.2
  * Drop patches merged upstream:
      fix-bigendian.patch
      remove-soname-python-module.patches
  * Rename debian/patches/tests-disable-distributed_python_wrapper.patch
    into debian/patches/tests-disable-coupling_tools.patch

 -- Denis Barbier <barbier@debian.org>  Thu, 25 Jul 2013 20:06:52 +0200

openturns (1.2~rc1-2) experimental; urgency=low

  [ Denis Barbier ]
  * debian/rules: Fix FTBFS on *-i386, copied from 1.1-8.

  [ Julien Schueller ]
  * debian/patches/fix-bigendian.patch: Patch rewritten to use
    CMake detection of endianness.

 -- Denis Barbier <barbier@debian.org>  Mon, 15 Jul 2013 20:47:24 +0200

openturns (1.2~rc1-1) experimental; urgency=low

  [Julien Schueller]
  * New upstream version 1.2rc1
  * Bump soname to 0.3
  * Drop patches merged upstream:
     add-missing-header-file.patch debian-soname.patch
     fix-swig-warning.patch ftbfs-bison-2.7.patch
  * Launch tests in parallel

 -- Denis Barbier <barbier@debian.org>  Fri, 28 Jun 2013 01:51:22 +0200

openturns (1.1-9) unstable; urgency=low

  [ Julien Schueller ]
  * debian/control: All libraries listed in OPENTURNS_LIBRARIES
    variable into OpenTURNSConfig.cmake must be installed in order
    to link against OT.  Let libopenturns-dev depend on
     libxml2-dev, liblapack-dev, libblas-dev, libtbb-dev [i386 amd64 ia64]

  [ Denis Barbier ]
  * debian/control: Replace Architecture: any by an hardcoded list
    of supported architectures.  Openturns requires more than 1GB RAM,
    this caused a lot of trouble on mips* architectures.

 -- Denis Barbier <barbier@debian.org>  Thu, 18 Jul 2013 19:10:04 +0200

openturns (1.1-8) unstable; urgency=low

  * debian/rules: Fix building source package on *-i386, there was
    trouble with debian/patches/modify-tests-O0-i386.patch.

 -- Denis Barbier <barbier@debian.org>  Fri, 05 Jul 2013 18:06:37 +0200

openturns (1.1-7) unstable; urgency=low

  * debian/patches/modify-tests-O0-i386.patch: On *-i386 architectures,
    algocobyla.c is compiled with -O0 flag since 1.1-6; output of
    two tests is modified.  Closes: #714915

 -- Denis Barbier <barbier@debian.org>  Thu, 04 Jul 2013 22:36:45 +0200

openturns (1.1-6) unstable; urgency=low

  * debian/rules: The previous change fixed C++ tests on kfreebsd-i386,
    but pyinstallcheck_Cobyla_nonlinear hangs.  There is another hang
    on i386.  The -fno-guess-branch-probability flag fixes the failure
    on kfreebsd-i386, but compile instead algocobyla.c with -O0 flag
    on *-i386 architectures to be safe.  Closes: #714411

 -- Denis Barbier <barbier@debian.org>  Tue, 02 Jul 2013 20:08:27 +0200

openturns (1.1-5) unstable; urgency=low

  * debian/rules: algocobyla.c is again miscompiled with gcc 4.8.1
    on kfreebsd-i386 and hurd-i386, cppcheck_TrapezoidalFactory_std
    and cppcheck_WhittleFactory_std hang; compile with -fno-caller-saves
    to avoid these problems.  Closes: #714411

 -- Denis Barbier <barbier@debian.org>  Sat, 29 Jun 2013 23:50:27 +0200

openturns (1.1-4) unstable; urgency=low

  * Upload into unstable
  * Bump Standards-Version to 3.9.4, no changes are needed.

 -- Denis Barbier <barbier@debian.org>  Thu, 27 Jun 2013 22:58:17 +0200

openturns (1.1-3) experimental; urgency=low

  * debian/rules: Adjust Python detection so that it works with
    multiarch and non-multiarch Python.
  * debian/patches/ftbfs-bison-2.7.patch: New patch, to fix build
    failures with newer Bison.
  * debian/patches/tests-disable-distributed_python_wrapper.patch:
    New patch, to disable distributed python wrapper tests, these
    tests sometimes fail in strange ways.
  * debian/patches/fix-swig-warning.patch: New patch, taken from
    upstream. Several tests are missing because of a behavior change
    in swig 2.0.9, fix .i files.

 -- Denis Barbier <barbier@debian.org>  Thu, 30 May 2013 23:51:47 +0200

openturns (1.1-2) experimental; urgency=low

  [ Julien Schueller ]
  * debian/rules: Install CMake files into /usr/lib/cmake/openturns
  * debian/patches/add-missing-header-file.patch: New patch, to
    install missing header file WrapperCommon_extern.h

  [ Denis Barbier ]
  * debian/patches/tests-disable-timing.patch: New patch, to disable
    test timings.  They are useless, and prevent openturns from
    building on Hurd.
  * debian/patches/remove-soname-python-module.patch: New patch, to
    remove SONAME from Python modules, this confuses dpkg-shlibdeps.
  * debian/control: Let openturns-examples explicitly depend on python.
  * debian/rules: Pass LDFLAGS when building shared libraries.
  * openturns-examples: Remove duplicates from /usr/lib/openturns/examples/.

 -- Denis Barbier <barbier@debian.org>  Tue, 05 Feb 2013 01:23:41 +0100

openturns (1.1-1) experimental; urgency=low

  [ Denis Barbier ]
  * New upstream version
  * License has been updated to LGPL-3+
  * Drop patches merged upstream:
      fix-dtd-search-path.patch install_cmake_files.patch
      kfreebsd-fix-t_WrapperFile_generic.patch
  * Let libopenturns-dev ship CMake files.
  * debian/watch: Check for tar.bz2 instead of tar.gz
  * debian/copyright: Convert to machine-readable format
    and add missing stanzas.

  [ Julien Schueller ]
  * debian/rules: Drop chmod calls, they are useless.
  * debian/rules: Removed useless clean override.
  * debian/control: Fix URL in Homepage field.

 -- Denis Barbier <barbier@debian.org>  Sun, 13 Jan 2013 09:46:40 +0100

openturns (1.1~rc1-3) experimental; urgency=low

  * debian/patches/kfreebsd-fix-t_WrapperFile_generic.patch: New
    patch to fix t_WrapperFile_generic.py failure on kfreebsd.

 -- Denis Barbier <barbier@debian.org>  Sun, 09 Dec 2012 21:39:44 +0100


